All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2013
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compability with git. In case git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
17 [ -z "$2" ] || f="${f%$2}"
25 echo "$SELF: fatal: $1" >&2
29 # We need to run getops as soon as possible so we catch -d and other
30 # options that will modify our behaviour.
31 # Commands are handled at the end of this script.
32 while getopts "c:dv" flag; do
33 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
36 elif [ "$1" = '-v' ];then
38 elif [ "$1" = '-c' ];then
39 VCSH_OPTION_CONFIG=$OPTARG
45 # Source file even if it's in $PWD and does not have any slashes in it
53 # Read configuration and set defaults if anything's not set
54 [ -n "$VCSH_DEBUG" ] && set -vx
55 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
57 # Read configuration files if there are any
58 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
59 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
60 if [ -n "$VCSH_OPTION_CONFIG" ]; then
61 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
62 if [ -r "$VCSH_OPTION_CONFIG" ]; then
63 source_all "$VCSH_OPTION_CONFIG"
65 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
68 [ -n "$VCSH_DEBUG" ] && set -vx
71 [ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
72 [ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
73 [ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
74 [ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
78 echo "usage: $SELF <options> <command>
83 -v Enable verbose mode
87 [<repo>] Clone from an existing repository
88 delete <repo> Delete an existing repository
89 enter <repo> Enter repository; spawn new instance of \$SHELL
90 help Display this help text
91 init <repo> Initialize a new repository
92 list List all repositories
93 list-tracked List all files tracked by vcsh
95 <repo> List files tracked by a repository
97 <newname> Rename repository
99 <command> Use this repository
100 setup <repo> Set up repository with recommended settings
101 version Print version information
102 which <substring> Find substring in name of any tracked file
104 <repo> Write .gitignore.d/<repo> via git ls-files
106 <repo> <git command> Shortcut to run git commands directly
107 <repo> Shortcut to enter repository" >&2
111 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
115 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
119 echo "$SELF: error: $1" >&2
123 echo "$SELF: info: $1"
128 git remote add origin "$GIT_REMOTE"
129 git config branch.master.remote origin
130 git config branch.master.merge refs/heads/master
131 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
132 info "remote is empty, not merging anything"
136 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
138 error "'$object' exists." &&
141 [ "$VCSH_CONFLICT" = '1' ] &&
142 fatal "will stop after fetching and not try to merge!
143 Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
144 git merge origin/master
148 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
150 info "This operation WILL DESTROY DATA!"
151 files=$(git ls-files)
152 echo "These files will be deleted:
156 AGAIN, THIS WILL DELETE YOUR DATA!
157 To continue, type 'Yes, do as I say'"
159 [ "x$answer" = 'xYes, do as I say' ] || exit 16
160 for file in $files; do
161 rm -f $file || info "could not delete '$file', continuing with deletion"
163 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
174 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
178 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
179 [ -x "$hook" ] || continue
180 verbose "executing '$hook'"
186 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
187 export GIT_WORK_TREE="$VCSH_BASE"
188 mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
189 cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
195 for repo in "$VCSH_REPO_D"/*.git; do
196 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
201 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
206 for VCSH_REPO_NAME in $(list); do
213 git ls-files | sort -u
218 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
219 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
233 git config core.worktree "$GIT_WORK_TREE"
234 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
235 git config vcsh.vcsh 'true'
236 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
242 export GIT_WORK_TREE="$(git config --get core.worktree)"
243 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
247 for VCSH_REPO_NAME in $(list); do
248 for VCSH_FILE in $(get_files); do
249 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
256 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
257 gitignores=$(for file in $(git ls-files); do
259 echo $file; new="${file%/*}"
260 [ "$file" = "$new" ] && break
264 tempfile=$(mktemp) || fatal "could not create tempfile" 51
265 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
266 for gitignore in $gitignores; do
267 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
268 if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
269 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
272 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
273 rm -f "$tempfile" || error "could not delete '$tempfile'"
276 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
277 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
278 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
279 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
281 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
282 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
285 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
286 fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
289 if [ "$1" = 'clone' ]; then
290 [ -z "$2" ] && fatal "$1: please specify a remote" 1
291 export VCSH_COMMAND="$1"
293 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
294 export VCSH_REPO_NAME
295 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
296 elif [ "$1" = 'version' ]; then
297 echo "$SELF $VERSION"
299 elif [ "$1" = 'which' ]; then
300 [ -z "$2" ] && fatal "$1: please specify a filename" 1
301 [ -n "$3" ] && fatal "$1: too many parameters" 1
302 export VCSH_COMMAND="$1"
303 export VCSH_COMMAND_PARAMETER="$2"
304 elif [ "$1" = 'delete' ] ||
305 [ "$1" = 'enter' ] ||
307 [ "$1" = 'list-tracked-by' ] ||
308 [ "$1" = 'rename' ] ||
310 [ "$1" = 'setup' ] ||
311 [ "$1" = 'write-gitignore' ]; then
312 [ -z $2 ] && fatal "$1: please specify repository to work on" 1
313 [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
314 [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
315 export VCSH_COMMAND="$1"
316 export VCSH_REPO_NAME="$2"
317 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
318 [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
319 [ "$VCSH_COMMAND" = 'run' ] && shift 2
320 [ "$VCSH_COMMAND" = 'write-gitignore' ]
321 elif [ "$1" = 'list' ] ||
322 [ "$1" = 'list-tracked' ]; then
323 export VCSH_COMMAND="$1"
324 elif [ -n "$2" ]; then
325 export VCSH_COMMAND='run'
326 export VCSH_REPO_NAME="$1"
327 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
328 [ -d $GIT_DIR ] || { help; exit 1; }
331 elif [ -n "$1" ]; then
332 export VCSH_COMMAND='enter'
333 export VCSH_REPO_NAME="$1"
334 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
335 [ -d $GIT_DIR ] || { help; exit 1; }
337 # $1 is empty, or 'help'
341 # Did we receive a directory instead of a name?
342 # Mangle the input to fit normal operation.
343 if echo $VCSH_REPO_NAME | grep -q '/'; then
344 export GIT_DIR=$VCSH_REPO_NAME
345 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
349 for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
351 if [ ! -d "$check_directory" ]; then
352 if [ -e "$check_directory" ]; then
353 fatal "'$check_directory' exists but is not a directory" 13
355 info "attempting to create '$check_directory'"
356 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
361 verbose "$VCSH_COMMAND begin"
362 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
366 verbose "$VCSH_COMMAND end, exiting"